#include "lab3d.h"
#ifdef USE_OSS
#define MUSIC_SOURCES 3
#else
#ifdef WIN32
#define MUSIC_SOURCES 3
#else
#define MUSIC_SOURCES 2
#endif
#endif

static int inputdevice=1,resolutionnumber=3,nearest=0;
static int music=1,sound=1,fullscr=1;

static char keynames[numkeys][30]={
    "Move FORWARD",
    "Move BACKWARD",
    "Turn LEFT",
    "Turn RIGHT",
    "STRAFE (walk sideways)",
    "STAND HIGH",
    "STAND LOW",
    "RUN",
    "FIRE",
    "FIREBALLS (red)",
    "BOUNCY-BULLETS (green)",
    "HEAT-SEEKING MISSILES",
    "UNLOCK / OPEN / CLOSE / USE",
    "CHEAT for more life",
    "RAISE / LOWER STATUS BAR",
    "PAUSE GAME",
    "MUTE KEY",
    "SHOW MENU"
};

static int newdefaultkey[numkeys]={
    SDLK_UP,
    SDLK_DOWN,
    SDLK_LEFT,
    SDLK_RIGHT,
    SDLK_RCTRL,
    SDLK_a,
    SDLK_z,
    SDLK_LSHIFT,
    SDLK_LCTRL,
    SDLK_F1,
    SDLK_F2,
    SDLK_F3,
    SDLK_SPACE,
    SDLK_BACKSPACE,
    SDLK_RETURN,
    SDLK_p,
    SDLK_m,
    SDLK_ESCAPE
};

static char inputdevicemenu[4][30]={
    "Keyboard only",
    "Keyboard + mouse",
    "Keyboard + joystick",
    "Keyboard + mouse + joystick"
};

static int resx[18]={360,512,640,800,1024,1152,1280,1600,
		     320,320,400,480,640,720,720,960,1920,1920};
static int resy[18]={240,384,480,600,768,864,1024,1200,
		     200,240,300,360,400,480,576,720,1080,1200};

static char resolutionmenu[18][30]={
    "360x240",
    "512x384",
    "640x480",
    "800x600",
    "1024x768",
    "1152x864",
    "1280x1024",
    "1600x1200",

    "320x200",
    "320x240",
    "400x300",
    "480x360",
    "640x400",
    "720x480",
    "720x576",
    "960x720",
    "1920x1080",
    "1920x1200"
};

static char fullscreenmenu[2][30]={
    "Windowed",
    "Fullscreen"
};

static char filtermenu[2][30]={
    "Trilinear filtering",
    "No filtering"
};

static char musicmenu[3][30]={
    "No music",
    "Adlib emulation",
    "General MIDI",
};

static char soundmenu[2][30]={
    "No sound",
    "Digital sound effects"
};

void selectionmenu(int alts,char titles[][30],int *value) {
    int i;

    drawmenu(304,12*alts+24,menu);
    
    for(i=0;i<alts;i++) {
	strcpy(textbuf,titles[i]);
	textprint(71,120-6*alts+12*i,32);
    }

    finalisemenu();

    i=getselection(28,99-6*alts,*value,alts);

    if (i>=0) *value=i;   
}

void setupinputdevices() {
    selectionmenu(4,inputdevicemenu,&inputdevice);
}

void setupsetresolution() {
    selectionmenu(18,resolutionmenu,&resolutionnumber);
}

void setupsetfullscreen() {
    selectionmenu(2,fullscreenmenu,&fullscr);
}

void setupsetfiltering() {
    selectionmenu(2,filtermenu,&nearest);
}

void setupsetmusic() {
    selectionmenu(MUSIC_SOURCES,musicmenu,&music);
}

void setupsetsound() {
    selectionmenu(2,soundmenu,&sound);
}

void setupsetkeys() {
    int i=0,j,quit=0,sk;
    SDL_Event event;

    i=0;
    while(!quit) {
	drawmenu(360,240,menu);
    
	for(j=0;j<numkeys;j++) {
	    strcpy(textbuf,keynames[j]);
	    textprint(31,13+12*j,32);
	    strncpy(textbuf,SDL_GetKeyName(newkeydefs[j]),11);
	    textbuf[11]=0;
	    textprint(261,13+12*j,32);
	}
    
	finalisemenu();
	i=getselection(-12,-9,i,numkeys);
	if (i<0) quit=1;
	else if (i>=numkeys) quit=1;
	else {
	    j=-1;
	    while(j<0) {
		while(SDL_PollEvent(&event))
		{
		    switch(event.type)
		    {	      
			case SDL_KEYDOWN:
			    sk=event.key.keysym.sym;
			    if (sk<SDLKEYS) {
				j=sk;
			    }
			    break;
			default:
			    break;
		    }
		}
		SDL_Delay(10);
	    }
	    newkeydefs[i]=j;
	}
    }
}

void setupmenu() {
    int quit=0,sel=0;

    while(!quit) {
	drawmenu(360,240,menu);

	strcpy(textbuf,"LAB3D/SDL setup menu");
	textprint(81,32,126);

	strcpy(textbuf,"Input: ");
	strcat(textbuf,inputdevicemenu[inputdevice]);
	textprint(51,68,32);
	strcpy(textbuf,"Set keys");
	textprint(51,80,32);
	strcpy(textbuf,"Resolution: ");
	strcat(textbuf,resolutionmenu[resolutionnumber]);
	textprint(51,92,64);
    	strcpy(textbuf,"Display type: ");
	strcat(textbuf,fullscreenmenu[fullscr]);
	textprint(51,104,64);
    	strcpy(textbuf,"Filtering: ");
	strcat(textbuf,filtermenu[nearest]);
	textprint(51,116,64);
    	strcpy(textbuf,"Music: ");
	strcat(textbuf,musicmenu[music]);
	textprint(51,128,96);
    	strcpy(textbuf,"Sound: ");
	strcat(textbuf,soundmenu[sound]);
	textprint(51,140,96);
    	strcpy(textbuf,"Exit setup");
	textprint(51,152,126);

	strcpy(textbuf,"Use cursor keys and Return to select.");
	textprint(31,200,32);

	finalisemenu();
	if ((sel = getselection(12,47,sel,8)) < 0)
	    quit=1;
	else {
	    switch(sel) {
		case 0:
		    setupinputdevices();
		    break;
		case 1:
		    setupsetkeys();
		    break;
		case 2:
		    setupsetresolution();
		    break;
		case 3:
		    setupsetfullscreen();
		    break;
		case 4:
		    setupsetfiltering();
		    break;
		case 5:
		    setupsetmusic();
		    break;
		case 6:
		    setupsetsound();
		    break;
		case 7:
		    quit=1;
		    break;
	    }
	}
    }
}

void configure() {
    screenwidth=resx[resolutionnumber]; screenheight=resy[resolutionnumber];
    fullscreen=fullscr;
    fullfilter=nearest?GL_NEAREST:GL_LINEAR_MIPMAP_LINEAR;
    partialfilter=nearest?GL_NEAREST:GL_LINEAR;
    speechstatus = sound?2:0;
    switch(music) {
	case 2:
	    musicsource=1;
	    break;	    
	case 1:
	    musicsource=2;
	    break;
	default:
	    musicsource=-1;
	    break;
    }
    moustat = ((3-inputdevice)&1);
    joystat = ((3-inputdevice)>>1);
}

void loadsettings() {
    FILE *file=fopen("settings.ini","r");
    int i;

    for(i=0;i<numkeys;i++)
	newkeydefs[i]=newdefaultkey[i];

    if (file==NULL) return; /* Use defaults. */
    i=fscanf(file,"%d %d %d %d %d %d",&inputdevice,&resolutionnumber,&fullscr,
	     &nearest,&music,&sound); /* Non-existent set to defaults. */
    if (i==6) {
	for(i=0;i<numkeys;i++)
	    if (fscanf(file,"%d\n",newkeydefs+i)!=1) break;
    } else i=0;

    fclose(file);
}

void savesettings() {
    FILE *file=fopen("settings.ini","w");
    int i;

    if (file==NULL) return;
    fprintf(file,"%d %d %d %d %d %d\n",inputdevice,resolutionnumber,fullscr,
	    nearest,music,sound);    
    for(i=0;i<numkeys;i++)
	fprintf(file,"%d\n",newkeydefs[i]);
    fclose(file);
}

void setup() {
    K_INT16 i, walcounter;
    K_UINT16 l;
    char *v;
    SDL_Surface *screen;

    /* Initialise SDL; uncomment the NOPARACHUTE bit if the parachute
       routine (which catches stuff like segfaults) gets in the way of your
       debugging. */

    /* Display accuracy not important in setup... */

    SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO/*|SDL_INIT_NOPARACHUTE*/|
	     SDL_INIT_JOYSTICK);
    SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
    SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE,5);
    SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE,5);
    SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE,0);
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);
    SDL_GL_SetAttribute(SDL_GL_STENCIL_SIZE,0);
    SDL_GL_SetAttribute(SDL_GL_ACCUM_RED_SIZE,0);
    SDL_GL_SetAttribute(SDL_GL_ACCUM_GREEN_SIZE,0);
    SDL_GL_SetAttribute(SDL_GL_ACCUM_BLUE_SIZE,0);
    SDL_GL_SetAttribute(SDL_GL_ACCUM_ALPHA_SIZE,0);
    SDL_ShowCursor(0);

    fprintf(stderr,"Activating video...\n");

    screenwidth=360; screenheight=240;

    if ((screen=SDL_SetVideoMode(screenwidth, screenheight, 32, 
				 SDL_OPENGL))==
	NULL) {
	fprintf(stderr,"Video mode set failed.\n");
	SDL_Quit();
	exit(-1);
    }

    screenwidth=screen->w;
    screenheight=screen->h;

    largescreentexture=0;
							      
    if (largescreentexture) {
	/* One large 512x512 texture. */

	screenbufferwidth=screenbufferheight=512;
    } else {
	/* 6*8 matrix of 64x64 tiles with 1 pixel wide borders on shared
	   edges. */

	screenbufferwidth=374;
	screenbufferheight=498;
    }

    screenbuffer=malloc(screenbufferwidth*screenbufferheight);    
    SDL_WM_SetCaption("Ken's Labyrinth", "Ken's Labyrinth");

    linecompare(479);

    if (screenbuffer==NULL) {
	fprintf(stderr,"Insufficient memory.\n");
	SDL_Quit();
	exit(-1);
    }
    
    fprintf(stderr,"Loading configuration file...\n");

    loadtables();
    loadsettings();
    fullfilter=partialfilter=GL_NEAREST;
    vidmode = 1; /* Force fake 360x240 mode. */
    mute = 0;
    moustat = 1;
    joystat = 1;

    musicsource=-1;
    speechstatus=0;

    fprintf(stderr,"Allocating memory...\n");
    if ((lzwbuf = convallocate(12304>>4)) == NULL)
    {
	fprintf(stderr,"Error #3:  Memory allocation failed.\n");
	SDL_Quit();
	exit(-1);
    }

    convwalls = numwalls;

    if ((pic = convallocate((numwalls-initialwalls)<<8)) == NULL)
    {
	fprintf(stderr,
		"Error #4: This computer does not have enough memory.\n");
	SDL_Quit();
	exit(-1);
    }
    walcounter = initialwalls;
    if (convwalls > initialwalls)
    {
	v = pic;
	for(i=0;i<convwalls-initialwalls;i++)
	{
	    walseg[walcounter] = v;
	    walcounter++;
	    v += 4096;
	}
    }
    l = 0;
    for(i=0;i<240;i++)
    {
	times90[i] = l;
	l += 90;
    }
    less64inc[0] = 16384;
    for(i=1;i<64;i++)
	less64inc[i] = 16384 / i;
    for(i=0;i<256;i++)
	keystatus[i] = 0;

    if (largescreentexture) {
	glGenTextures(1,&screenbuffertexture);
    } else {
	glGenTextures(48,screenbuffertextures);
    }

    saidwelcome = 0;
    fprintf(stderr,"Loading intro pictures...\n");

    /* The ingame palette is stored in this GIF! */
    kgif(1);
    memcpy(spritepalette,palette,768);

    kgif(0);
    settransferpalette();
    fprintf(stderr,"Loading graphics...\n");
    loadwalls();

    kgif(1);
    fade(63);

    glDrawBuffer(GL_FRONT);
    setupmenu();
  
    savesettings();
    SDL_Quit();
    exit(0);

}
